/* Title: Main Tree Message Loop Procedure
   Name: Eric Walsh
   Description: This file contains the main Message loop for the tree routines.
*/

#include <windows.h>
#include "drvclass.h"
#include "drive.h"

extern "C" long FAR PASCAL DriveWindowProc(HWND hWnd, WORD message, WORD wParam, LONG lParam );

long FAR PASCAL DriveWindowProc(HWND hWnd, WORD message, WORD wParam, LONG lParam )
{
	drvcntl *ptc;

	ptc =(drvcntl *)GetWindowLong(hWnd, 0);
	switch (message)
	{
		case WM_CREATE:
			ptc =new drvcntl(hWnd);

			SetWindowLong(hWnd, 0, (LONG)ptc);
			break;

		case DR_GETACTIVEDRIVE:
			return ptc->GetActiveDrive();

		case DR_GETNUMDRIVES:
			return ptc->GetNumDrives();

		case DR_GETDRIVESTATE:
			return ptc->GetDriveState(wParam);

		case DR_GETNUMACTIVEDRIVES:
			return ptc->GetNumActiveDrives();

		case WM_MOVE:
		case WM_SIZE:
			return ptc->WinSpec();

		case WM_SETCURSOR:
			break;

		case WM_COMMAND:
			return ptc->ProcessButtons(wParam, lParam);

		case WM_DESTROY:
			ptc->~drvcntl();
			return FALSE;

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return FALSE;
}

